



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>JDK源码中使用的设计模式</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">JDK源码中使用的设计模式</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 00:46:30 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<div>
<h2>结构型模式：</h2>
<h3>适配器模式：</h3>
<pre class="prettyprint linenums">用来把一个接口转化成另一个接口。</pre>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">java.util.Arrays#asList()<br />
javax.swing.JTable(TableModel)<br />
java.io.InputStreamReader(InputStream)<br />
java.io.OutputStreamWriter(OutputStream)<br />
javax.xml.bind.annotation.adapters.XmlAdapter#marshal()<br />
javax.xml.bind.annotation.adapters.XmlAdapter#unmarshal()</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<h3>桥接模式：</h3>
<pre class="prettyprint linenums">这个模式将抽象和抽象操作的实现进行了解耦，这样使得抽象和实现可以独立地变化。</pre>
<div>
<pre class="prettyprint linenums">AWT (It provides an abstraction layer which maps onto the native OS the windowing support.)<br />JDBC</pre>
</div>
<h3>组合模式：</h3>
<p>使得客户端看来单个对象和对象的组合是同等的。换句话说，某个类型的方法同时也接受自身类型作为参数。</p>
<div>
<pre class="prettyprint linenums">javax.swing.JComponent#add(Component)<br />
java.awt.Container#add(Component)<br />
java.util.Map#putAll(Map)<br />
java.util.List#addAll(Collection)<br />
java.util.Set#addAll(Collection)</pre>
</div>
<h3>装饰者模式：</h3>
<p>动态的给一个对象附加额外的功能，这也是子类的一种替代方式。可以看到，在创建一个类型的时候，同时也传入同一类型的对象。</p>
<p>这在JDK里随处可见，你会发现它无处不在，所以下面这个列表只是一小部分。</p>
<div>
<pre class="prettyprint linenums">java.io.BufferedInputStream(InputStream)<br />
java.io.DataInputStream(InputStream)<br />
java.io.BufferedOutputStream(OutputStream)<br />
java.util.zip.ZipOutputStream(OutputStream)<br />
java.util.Collections#checkedList|Map|Set|SortedSet|SortedMap</pre>
</div>
<h3>门面模式：</h3>
<p>给一组组件，接口，抽象，或者子系统提供一个简单的接口。</p>
<div>
<pre class="prettyprint linenums">java.lang.Class<br />
javax.faces.webapp.FacesServlet</pre>
</div>
<h3>享元模式：</h3>
<p>使用缓存来加速大量小对象的访问时间。</p>
<div>
<pre class="prettyprint linenums">java.lang.Integer#valueOf(int)<br />
java.lang.Boolean#valueOf(boolean)<br />
java.lang.Byte#valueOf(byte)<br />
java.lang.Character#valueOf(char)</pre>
</div>
<h3>代理模式：</h3>
<p>代理模式是用一个简单的对象来代替一个复杂的或者创建耗时的对象。</p>
<div>
<pre class="prettyprint linenums">java.lang.reflect.Proxy<br />
RMI</pre>
</div>
<h2>创建模式</h2>
<h3>抽象工厂模式：</h3>
<p>抽象工厂模式提供了一个协议来生成一系列的相关或者独立的对象，而不用指定具体对象的类型。</p>
<p>它使得应用程序能够和使用的框架的具体实现进行解耦。这 在JDK或者许多框架比如Spring中都随处可见。</p>
<p>它们也很容易识别，一个创建新对象的方法，返回的却是接口或者抽象类的，就是抽象工厂模式了。</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">java.util.Calendar#getInstance()<br />
java.util.Arrays#asList()<br />
java.util.ResourceBundle#getBundle()<br />
java.sql.DriverManager#getConnection()<br />
java.sql.Connection#createStatement()<br />
java.sql.Statement#executeQuery()<br />
java.text.NumberFormat#getInstance()<br />
javax.xml.transform.TransformerFactory#newInstance()</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<h3>建造模式：(Builder)</h3>
<p>定义了一个新的类来构建另一个类的实例，以简化复杂对象的创建。建造模式通常也使用方法链接来实现。</p>
<div>
<pre class="prettyprint linenums">java.lang.StringBuilder#append()<br />
java.lang.StringBuffer#append()<br />
java.sql.PreparedStatement<br />
javax.swing.GroupLayout.Group#addComponent()</pre>
</div>
<h3>工厂方法：</h3>
<p>就是一个返回具体对象的方法。</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">java.lang.Proxy#newProxyInstance()<br />
java.lang.Object#toString()<br />
java.lang.Class#newInstance()<br />
java.lang.reflect.Array#newInstance()<br />
java .lang.reflect.Constructor#newInstance()<br />
java.lang.Boolean#valueOf(String)<br />
java.lang.Class#forName()</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<h3>原型模式：</h3>
<p>使得类的实例能够生成自身的拷贝。如果创建一个对象的实例非常复杂且耗时时，就可以使用这种模式，而不重新创建一个新的实例，你可以拷贝一个对象并直接修改它。</p>
<div>
<pre class="prettyprint linenums">java.lang.Object#clone()<br />
java.lang.Cloneable</pre>
</div>
<h3>单例模式：</h3>
<p>用来确保类只有一个实例。Joshua Bloch在Effetive Java中建议到，还有一种方法就是使用枚举。</p>
<div>
<pre class="prettyprint linenums">java.lang.Runtime#getRuntime()<br />
java.awt.Toolkit#getDefaultToolkit()<br />
java.awt.GraphicsEnvironment#getLocalGraphicsEnvironment()<br />
java.awt.Desktop#getDesktop()</pre>
</div>
<h2>行为模式</h2>
<h3>责任链模式：</h3>
<p>通过把请求从一个对象传递到链条中下一个对象的方式，直到请求被处理完毕，以实现对象间的解耦。</p>
<div>
<pre class="prettyprint linenums">java.util.logging.Logger#log()<br />
javax.servlet.Filter#doFilter()</pre>
</div>
<h3>命令模式：</h3>
<p>将操作封装到对象内，以便存储，传递和返回。</p>
<div>
<pre class="prettyprint linenums">java.lang.Runnable<br />
javax.swing.Action</pre>
</div>
<h3>解释器模式：</h3>
<p>这个模式通常定义了一个语言的语法，然后解析相应语法的语句。</p>
<div>
<pre class="prettyprint linenums">java.util.Pattern<br />
java.text.Normalizer<br />
java.text.Format</pre>
</div>
<h3>迭代器模式：</h3>
<p>提供一个一致的方法来顺序访问集合中的对象，这个方法与底层的集合的具体实现无关。</p>
<div>
<pre class="prettyprint linenums">java.util.Iterator<br />
java.util.Enumeration</pre>
</div>
<h3>中介者模式：</h3>
<p>通过使用一个中间对象来进行消息分发以及减少类之间的直接依赖。</p>
<div>
<pre class="prettyprint linenums">java.util.Timer<br />
java.util.concurrent.Executor#execute()<br />
java.util.concurrent.ExecutorService#submit()<br />
java.lang.reflect.Method#invoke()</pre>
</div>
<h3>备忘录模式：</h3>
<p>生成对象状态的一个快照，以便对象可以恢复原始状态而不用暴露自身的内容。Date对象通过自身内部的一个long值来实现备忘录模式。</p>
<div>
<pre class="prettyprint linenums">java.util.Date<br />
java.io.Serializable</pre>
</div>
<h3>空对象模式：</h3>
<p>这个模式通过一个无意义的对象来代替没有对象这个状态。它使得你不用额外对空对象进行处理。</p>
<div>
<pre class="prettyprint linenums">java.util.Collections#emptyList()<br />
java.util.Collections#emptyMap()<br />
java.util.Collections#emptySet()</pre>
</div>
<h3>观察者模式：</h3>
<p>它使得一个对象可以灵活的将消息发送给感兴趣的对象。</p>
<div>
<pre class="prettyprint linenums">java.util.EventListener<br />
javax.servlet.http.HttpSessionBindingListener<br />
javax.servlet.http.HttpSessionAttributeListener<br />
javax.faces.event.PhaseListener</pre>
</div>
<h3>状态模式：</h3>
<p>通过改变对象内部的状态，使得你可以在运行时动态改变一个对象的行为。</p>
<div>
<pre class="prettyprint linenums">java.util.Iterator<br />
javax.faces.lifecycle.LifeCycle#execute()</pre>
</div>
<h3>策略模式：</h3>
<p>使用这个模式来将一组算法封装成一系列对象。通过传递这些对象可以灵活的改变程序的功能。</p>
<div>
<pre class="prettyprint linenums">java.util.Comparator#compare()<br />
javax.servlet.http.HttpServlet<br />
javax.servlet.Filter#doFilter()</pre>
</div>
<h3>模板方法模式：</h3>
<p>让子类可以重写方法的一部分，而不是整个重写，你可以控制子类需要重写那些操作。</p>
<div>
<pre class="prettyprint linenums">java.util.Collections#sort()<br />
java.io.InputStream#skip()<br />
java.io.InputStream#read()<br />
java.util.AbstractList#indexOf()</pre>
</div>
<h3>访问者模式：</h3>
<p>提供一个方便的可维护的方式来操作一组对象。它使得你在不改变操作的对象前提下，可以修改或者扩展对象的行为。</p>
<div>
<pre class="prettyprint linenums">javax.lang.model.element.Element<br />javax.lang.model.element.ElementVisitor<br />
javax.lang.model.type.TypeMirror<br />javax.lang.model.type.TypeVisitor</pre>
</div>
<p><hr />
<pre class="prettyprint linenums">感谢阅读，如果本文对您有帮助，欢迎<strong>推荐</strong>和<strong>转载</strong>！</pre>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q20e2w9.html">XlFileFormat Enumeration</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlw3n68.html">Java中类继承、接口实现的一些细节（长期更新）</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql7k1k9.html">【HDU 5835】Danganronpa（分配礼物）</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q73j5x8.html">MyCCL特征码定位原理学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvm7joq.html">甘特图和PERT图</a>
		</li>
						<li><a href="https://www.batexi.com/a/r934kl08.html">JVM调优-关于jvm的一些基本概念</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx1jod9.html">Mac OS X 上的安装Lisp开发环境</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqly3vx9.html">C&num;学习笔记（五）&mdash;&mdash;函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yy530q.html">笔记8：winfrom连接数据库DBHelp</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdvpo38.html">Informix 中执行多条SQL&lpar;Execute Script&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z47v49.html">Posting data to a HttpHandler greater then ~29MB gives a 404 error</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v15mj8.html">JSP九大内置对象和四个作用域</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wvw1wq.html">MySQL函数讲解&lpar;MySQL函数大全&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wn1xwq.html">WebApp触屏版网站开发要点</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmyw2l9.html">【转】jQuery教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xkzj08.html">git 七图七模式 -- 工作流</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj0lzy9.html">回文数猜想（hd1282）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzgjk08.html">IdentityServer（15）- 第三方快速入门和示例</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdl1m49.html">Android OpenGL ES 开发（四）&colon; OpenGL ES 绘制形状</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5zx27q.html">STL空间配置器、vector、list、deque、map复习</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q4jydj5q.html">Linux装系统问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4jyd45q.html">51单片机---点亮一个LED灯</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1ky6pq.html">java 环境的安装、设置免密登陆、进行hadoop安装、关闭防火墙</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4jy7ojq.html">python 迭代器 一个奇怪的解决方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4jy31eq.html">如何打开kernel最开始的打印</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwjvo48.html">【Jest】笔记一：环境配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllmxg1q.html">cordova原生页面切换效果插件的使用：com&period;telerik&period;plugins&period;nativepagetransitions</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2nzz6q.html">面向对象A 知识点总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e412gx9.html">cookie 就是一些字符串信息</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rvnpm9.html">c&plus;&plus;&mdash;&mdash;大端序，小端序的排列问题</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
